	SECTION	text
	XDEF	PWscrsize
	XREF	chan_num



*****************************************************************************
*
*	PWscrsize gets permissible window size
*
*	syntax:	PWscrsize [#chan%],xs%,ys%,xo%,yo%
*	where xs% & ys% will contain the scr_size,xo% & yo% are origins
*	if chan not given, #0 is used
*	v. 1.00		1996 Aug 06 11:11:04
*
*	. W. Lenerz 1996
*
****************************************************************************

bp_err	MOVEQ	#-15,D0
	RTS
PWscrsize BSR	chan_num		; get channel ID into D0
	BNE.S	bp_err
	MOVE.L	A3,D0
	ADD.L	#32,D0
	SUB.L	A5,D0
	BNE.S	bp_err
	MOVE.L	A3,A4
	MOVEQ	#3,D1
test_int	MOVE.W	(A6,A4.L),D0
	ANDI.B	#$F,D0
	CMP.B	#3,D0		; is parameter an integer?
	BNE.S	bp_err
	ADDQ.L	#8,A4
	DBF	D1,test_int
	MOVEQ	#8,D1
	MOVE.W	$11A,A2
	JSR	(A2)		; get space on maths stack
	MOVE.L	$58(A6),A1
	SUBQ.L	#8,A1
	MOVEQ	#0,D2
	MOVEQ	#-1,D3
	MOVEQ	#$6C,D0		: IOP.FLIM
	TRAP	#4
	TRAP	#3
	TST.W	D0
	BNE.S	scrszout
	MOVE.L	(A6,A1.L),D7	; x,y sizes
	MOVE.L	4(A6,A1.L),D5	; x,y origins
	BSR.S	retpar
	MOVE.L	D5,D7

retpar	SWAP	D7
	MOVE.L	$58(A6),A1	; re-adjust stack
	SUBQ.L	#2,A1
	MOVE.W	D7,(A6,A1.L)
	MOVE.L	A1,$58(A6)
	MOVE.W	$120,A2
	JSR	(A2)		; return param
	ADDQ.L	#8,A3
	SWAP	D7
	MOVE.L	$58(A6),A1	; re-adjust stack
	SUBQ.L	#2,A1
	MOVE.W	D7,(A6,A1.L)
	MOVE.L	A1,$58(A6)
	MOVE.W	$120,A2
	JSR	(A2)		; return param
	ADDQ.L	#8,A3
	MOVEQ	#0,D0
scrszout	RTS


	end
