; this is the pwcreate keyword for the Prowess Sbasic interface
; v. 1.02 	1997 Dec 15 12:30:10
;  copyright (c) W. Lenerz, 1996


*****************************************************************************
*
* SYNTAX OF THIS FUNCTION
*
*	object=PWCREATE(owner,type,tag[,taglist...])
* where:
*	object  = the object, returned by this function, if there was an error
*		during the prowess routine, this will be 0
*	owner   = the owner of this object (either another object or 0)
*	type    = the type indicator of this object(1 LW)
*	taglist = the taglist i.e. a function number followed by its parameters
*
*
*****************************************************************************

	section	text

	include	asm_includes_asm

	xdef	pwcreate		; my keyword

	xref	_pwcreate 	; in libpw_a
	xref	gu_rchp		; releases mem (gu_rechp)
	xref	rt_fp		; return fp to basic (lib_returnparams)
	xref	get_all		; gets all parameters (prowess_asm_getparams)
	xref	gmem		; gets mem for myself, put things on..
	xref	gmem2		; ...stack, sets D7 (prowess_asm_gmem)
	xref	e_o		; rel mem & rts with error (prowess_asm_pwactivate)
	xref	pwquery2

PW_TYPE_MENU	EQU	$4d454e55
PW_MENU_BASIC_TRUEMENU	  EQU	$100010CC



pwcreate	BSR	gmem		; get mem, set up stack
	BSR	get_all		; get params from basic, put them on stack
	BNE	e_o		; oops
continue	MOVE.L	4(A4),-(A7)	; this is the type
	MOVE.L	(A4),-(A4)	; owner is first parameter on stack
	MOVE.L	A0,D0		; point to bottom of stack after possible strings
	ADDQ.L	#7,D0		; make sure we point to somewhere safe
	BCLR	#0,D0		; pointer to pointer to object
	MOVE.L	D0,4(A4)		; now on stack
	MOVE.L	D0,-(A7)		; keep this
	MOVE.L	D7,A1		; since we changed the stack pointer, change it here,too
	MOVE.L	A7,(A1)		; keep pointing to my stack
	MOVE.L	A4,A7		; point to false stack
	BSR	_pwcreate 	; create now
	reset_stk 		; get everything back from stack
	MOVE.L	(A7)+,A1		; pointer to pointer to my object
	MOVE.L	(A7)+,D2		; my menu type
	TST.L	D0		; call to Prowess ok?
	BEQ.S	ok		; yes->...
	BSR	gu_rchp		; no, so return 0!
	MOVEQ	#0,D2
	BRA	rt_fp
ok	CMP.L	#PW_TYPE_MENU,D2	; did we create a menu?
	BEQ.S	is_menu		; yes->...
	MOVE.L	(A1),D2		; point to object now
out	BSR	gu_rchp		; get rid of memory now
	BRA	rt_fp		; return floating point to basic
is_menu	BSR	gmem2		; reset stack etc...
	MOVE.L	#0,-(A4)
	MOVE.L	A0,-(A4)		; return
	MOVE.L	#PW_MENU_BASIC_TRUEMENU,-(A4) ; query tag
	MOVE.L	(A1),-(A4)	; ask this object
	BRA	pwquery2		; and return answer to basic
		end
